#include <stdio.h>

const int b0= 0x00001;
const int b1= 0x00002;
const int b2= 0x00004;
const int b3= 0x00008;
const int b4= 0x00010;
const int b5= 0x00020;
const int b6= 0x00040;
const int b7= 0x00080;
const int b8= 0x00100;
const int b9= 0x00200;
const int b10= 0x00400;
const int b11= 0x00800;
const int b12= 0x01000;
const int b13= 0x02000;
const int b14= 0x04000;
const int b15= 0x08000;
const int b16= 0x10000;
const int b17= 0x20000;
const int b18= 0x40000;
const int b19= 0x80000;
const int v1= b14+b8+b1;
const int v2= b8+b0+b16+b3+b9;
const int v3= b9+b2+b18;
const int v4= b14+b0+b10+b5+b15;
const int v5= b10+b1+b16+b2+b11+b7+b17+b4;
const int v6= b19+b6+b11+b3+b18;
const int v7= b15+b4+b12;
const int v8= b12+b5+b17+b6+b13;
const int v9= b13+b7+b19;

const int bv[]= {
  0x00001, 0x00002, 0x00004, 0x00008, 
  0x00010, 0x00020, 0x00040, 0x00080, 
  0x00100, 0x00200, 0x00400, 0x00800, 
  0x01000, 0x02000, 0x04000, 0x08000, 
  0x10000, 0x20000, 0x40000, 0x80000
};

const int btc[]= {		// Which other bits those bits touch (including themselves)
  v4|v2, v1|v5, v3|v5, v2|v6,
  v5|v7, v4|v8, v6|v8, v5|v9,
  v1|v2, v2|v3, v4|v5, v5|v6,
  v7|v8, v8|v9, v1|v4, v4|v7,
  v2|v5, v5|v8, v3|v6, v6|v9
};



int cnt= 0;
int tcnt= 0;
int nb;

void Try(int);
void Print(int);

int main() {
  int vv[20];
  for (nb= 1; nb<11; nb++) {
    memcpy(vv, &bv[20-nb], nb*sizeof(int));
    while (1) {
      int a, b;
      for (a= 0, b= nb; b-- >= 0; )  a |= vv[b];
      Try(a);
      for (a= 0; a<nb; a++) {
	if (vv[a]>>a == 1) continue;
	vv[a] >>= 1;
	while (a-- > 0) vv[a]= vv[a+1]>>1;
	break;
      }
      if (a == nb) break;
    }
  }
  
  //  printf("%d\n", cnt);
}

inline int mbit(int a) { 
  return (a & (a-1));
  /*  int cnt= 0;
  while (a) { a &= a-1; cnt++; }
  return cnt > 1;
  //  return a&(a-1);
  */
}

void Try(int a) {
  tcnt++;
  //  if ((tcnt & 4095) == 0)
  //    printf("%d %d %d\n", nb, tcnt, cnt);

  // No diagonals crossing one another
  if (a & (a>>1) & 0x55) return;

  // Forget those with nothing on left
  if ((a & (v1|v4|v7)) == 0) return;

  // Forget those with anything on right
  if ((a & (v3|v6|v9)) != 0) return;
  
  // Knock out neighbours to check that all are connected
  int c, b= a;
  for (c= 0; c<20; c++) if (b & bv[c]) break;
  int chk= 0;
  while (1) {
    b &= ~bv[c];
    if (b == 0) break;
    if ((b & btc[c]) == 0) return;		// Not touching anything
    chk |= btc[c];
    for (c= 0; c<20; c++) if (b & chk & bv[c]) break;
  }

  // Count strokes - maximum 5
  int str= 0;
  if (a & (b8|b9)) str++;
  if (a & (b10|b11)) str++;
  if (a & (b12|b13)) str++;
  if (a & (b14|b15)) str++;
  if (a & (b16|b17)) str++;
  if (a & (b18|b19)) str++;
  if (a & (b1|b7)) str++;
  if (a & (b2|b4)) str++;
  if (a & b0) str++;
  if (a & b3) str++;
  if (a & b5) str++;
  if (a & b6) str++;
  if (str > 5) return;

  // Eliminate glyphs with little triangular groups-of-three
  if (((a & b0) && (mbit(a & btc[0] & v1) || mbit(a & btc[0] & v5))) ||
      ((a & b1) && (mbit(a & btc[1] & v2) || mbit(a & btc[1] & v4))) ||
      ((a & b2) && (mbit(a & btc[2] & v2) || mbit(a & btc[2] & v6))) ||
      ((a & b3) && (mbit(a & btc[3] & v3) || mbit(a & btc[3] & v5))) ||
      ((a & b4) && (mbit(a & btc[4] & v4) || mbit(a & btc[4] & v8))) ||
      ((a & b5) && (mbit(a & btc[5] & v5) || mbit(a & btc[5] & v7))) ||
      ((a & b6) && (mbit(a & btc[6] & v5) || mbit(a & btc[6] & v9))) ||
      ((a & b7) && (mbit(a & btc[7] & v6) || mbit(a & btc[7] & v8))))
    return;
  
  cnt++;
  printf("%d\n", a);
  //  Print(a);
}

void Print(int a) {
  printf("%c%c%c%c%c\n",
	 (a&v1)?'+':' ',
	 (a&b8)?'-':' ',
	 (a&v2)?'+':' ',
	 (a&b9)?'-':' ',
	 (a&v3)?'+':' ');
  printf("%c%c%c%c%c\n",
	 (a&b14)?'|':' ',
	 (a&b0)?'/':(a&b1)?'\\':' ',
	 (a&b16)?'|':' ',
	 (a&b2)?'/':(a&b3)?'\\':' ',
	 (a&b18)?'|':' ');
  printf("%c%c%c%c%c\n",
	 (a&v4)?'+':' ',
	 (a&b10)?'-':' ',
	 (a&v5)?'+':' ',
	 (a&b11)?'-':' ',
	 (a&v6)?'+':' ');
  printf("%c%c%c%c%c\n",
	 (a&b15)?'|':' ',
	 (a&b4)?'/':(a&b5)?'\\':' ',
	 (a&b17)?'|':' ',
	 (a&b6)?'/':(a&b7)?'\\':' ',
	 (a&b19)?'|':' ');
  printf("%c%c%c%c%c\n",
	 (a&v7)?'+':' ',
	 (a&b12)?'-':' ',
	 (a&v8)?'+':' ',
	 (a&b13)?'-':' ',
	 (a&v9)?'+':' ');
  printf("\n");
}


